// js/IssueCollectionView.js

var Digifi = Digifi || {};

Digifi.SubscriptionCollectionView = Backbone.View.extend({
    el: '#subscriptions',
    tagName: 'p',
    
    initialize: function() {
        this.listenTo(this.model, 'add', this.modelAdded);
        this.listenTo(this.model, 'remove', this.modelRemoved);
    },
    
    modelAdded : function(inModel, inCollection, eventObject) {
        Tunnel.log('SubsriptionModelAdded');
        console.log(inModel);
        this.$el.append(new Digifi.SubscriptionView({model: inModel}).render().el);
    },
    
    modelRemoved : function(inModel, inCollection, eventObject) {
        console.log('SubsriptionModelAdded');
        console.log(inModel);
//        inModel.removed();
    }
});

Digifi.IssueCollectionView = Backbone.View.extend({
    el: '.library',

    initialize: function() {   
        this.listenTo(this.model, 'add', this.modelAdded);
        this.listenTo(this.model, 'remove', this.modelRemoved);
    },
    
    modelAdded : function(inModel, inCollection, eventObject) {
        var issueView = new Digifi.IssueView({ model: inModel });
        this.$el.append(issueView.render().el);

        // Request the preview image
        Backbone.trigger('GET_PREVIEW_IMAGE', inModel);
    },
    
    modelRemoved : function(inModel, inCollection, eventObject) {
        inModel.removed();
    },
                                                  
    /**
    * @param issue Model e.g added/remove/merged as defined by eventDetails
    * @param collection //XXX I think it's the collection model that the issue is related to
    * @param eventDetails Object e.g. {add: true, merge: false, remove: false} 
    * this == View
    */
//    changed : function(issue, collection, eventDetails) {
//        console.log('changed start');
//        for (var i = 0; i < arguments.length; i++){
//            console.log(arguments[i]);
//        }
//        console.log('changed end');
//        this.render();
//    },
//

//    events: {
//      'click #gridflow-button': 'gridflowClicked',
//      'click #coverflow-button': 'coverflowClicked'
//    },

    // defaults: {
    // 	isGridLayout: true
    // },

//    // render library by rendering each issue in its collection
//    render: function() {
//        for (var i=0; i < this.model.length; i++) {
////            console.log("Model at:" + i);
////            console.log(this.model.at(i));
//            this.$el.append(new Digifi.IssueView({model: this.model.at(i)}).render().el);
//        }
//    },

    // render an issue by creating a issueView and appending the
    // element it renders to the library's element
//    renderIssue: function( item ) {
//        var issueView = new Digif.IssueView();
//        this.$el.append( issueView.render().el );
//    },
//
//    renderGridLayout: function() {
//    	console.log("renderGridLayout");
//    },
//
//    renderCoverLayout: function() {
//    	console.log("renderCoverLayout");
//    },
//
//    gridflowClicked: function() {
//    	console.log("gridflowClicked");
//    	this.model.set('isGridLayout', true);
//    },
//
    coverflowClicked: function() {
    	console.log("coverflowClicked");
    	this.model.set('isGridLayout', false);
    }

});