// js/IssueModel.js
var Digifi = Digifi || {};

Digifi.IssueRow = Backbone.Model.extend({

    initialize: function() {
        this.issueModels = new Digifi.IssueModels;
    },

    size: function() {
        return this.issueModels.size();
    },

    add: function(issueModel) {
        this.issueModels.add(issueModel);
        Backbone.trigger('add', this.issueModels);
    }

});

Digifi.IssueModel = Backbone.Model.extend({

	idAttribute:"publication_issue_uuid",

	defaults: {
		title: "title",
        issue_name: "issue_name",
        is_current_issue: false,
		description: "description",
		discriminator: "discriminator",
		price: "-",
		bundle_state: BundleState.DOWNLOADED, // Default state to show View button on Web
        progress: 100,
        pretty_progress: '',
        preview_src: 'img/previewPlaceHolder.png',
        coverflow_src: '',
        is_login_only: false,
        user_can_download: false,
        is_free: false
	},
    
    removed : function() {
        console.log('removed model');
        this.trigger('REMOVED', this);
    }
});

Digifi.UserModel = Backbone.Model.extend({

	idAttribute:"uuid",

	defaults: {
        login_state: LoginState.LOGGED_OUT,
		email: '',
        settings: {},
        confirmed: false // Is the account email address confirmed
	},
    
    initialize: function() {
        this.on('change:login_state', this.loginStateChanged)     
    },
    
    loginStateChanged: function() {
        Tunnel.log('Login state changed to: ' + this.get('login_state'));   
    }
});

Digifi.SubscriptionModel = Backbone.Model.extend({

	idAttribute:"iap_product_id",

	defaults: {
        price: "-",
        subscribed: 0
    },
    
    initialize: function() {}
});

Digifi.DiagnosticsModel = Backbone.Model.extend({

    defaults: {
        appVersion: "1",
        enabled: 0,
        submittingLogs: false
    }, 

    initialize: function() {
        this.on('change:enabled', this.diagnosticsSwitchChanged);
    },

    diagnosticsSwitchChanged: function() {
        if(this.get('enabled') === 1) {
            Tunnel.out({event : 'ENABLE_DIAGNOSTICS'});
        } else {
            Tunnel.out({event : 'DISABLE_DIAGNOSTICS'});
        }
    }
});